Index: branches/src/ProcessManagement/ProcessManagement/Common/Process/ClsProcessExist.cs
===================================================================
--- branches/src/ProcessManagement/ProcessManagement/Common/Process/ClsProcessExist.cs	(revision 50)
+++ branches/src/ProcessManagement/ProcessManagement/Common/Process/ClsProcessExist.cs	(revision 51)
@@ -50,8 +50,43 @@
         private static int m_ConstructionCode = 0;
         #endregion
 
+        #region 結合工事フラグ
+        /// <summary>
+        /// 結合工事フラグ
+        /// </summary>
+        private static int m_BaseInfoJoinFlg = 0;
         #endregion
 
+        #region 増減工事フラグ
+        /// <summary>
+        /// 増減工事フラグ
+        /// </summary>
+        private static int m_BaseInfoTyingFlg = 0;
+        #endregion
+
+        #region 結合親工事コード
+        /// <summary>
+        /// 結合親工事コード
+        /// </summary>
+        private static int m_SearchCode = 0;
+        #endregion
+
+        #region 結合構成工事コード
+        /// <summary>
+        /// 結合構成工事コード
+        /// </summary>
+        private static List<int> m_CodeList = new List<int>();
+        #endregion
+
+        #region 機能承認回数
+        /// <summary>
+        /// 機能承認回数
+        /// </summary>
+        private static int m_OrderNo = 1;
+        #endregion
+
+        #endregion
+
         #region プロパティ
 
         #region 工事番号
@@ -65,32 +100,58 @@
         }
         #endregion
 
+        #region 機能承認回数
+        /// <summary>
+        /// 機能承認回数
+        /// </summary>
+        public static int OrderNo
+        {
+            get { return m_OrderNo; }
+            set { m_OrderNo = value; }
+        }
         #endregion
 
-        #region 紐付きの場合は親コードを返す
+        #endregion
+
+        #region 増減工事・結合工事の場合は親コードを返す
         /// <summary>
-        /// 紐付きの場合は親コードを返す
+        /// 増減工事・結合工事の場合は親コードを返す
         /// </summary>
-        /// <param name="MyType"></param>
-        /// <param name="MyCode"></param>
+        /// <param name="InputCode"></param>
         /// <returns></returns>
-        public static int GetParentConstrCode(int MyCode)
+        public static int GetParentConstrCode(int InputCode)
         {
             IOConstructionBaseInfo BaseDB = new IOConstructionBaseInfo();
             IOConstructionLink LinkDB = new IOConstructionLink();
             try
             {
-
-                string strBase = BaseDB.CreatePrimarykeyString(MyCode);
+                // 工事情報取得
+                string strBase = BaseDB.CreatePrimarykeyString(InputCode);
                 ConstructionBaseInfo BaseRec = new ConstructionBaseInfo();
-                if (!BaseDB.SelectAction(strBase, ref BaseRec)) return MyCode;
+                if (!BaseDB.SelectAction(strBase, ref BaseRec)) return InputCode;
 
-                // 紐付きでない場合は工事コードを返す
-                if (BaseRec.TyingFlg != (int)CommonDefine.BaseInfoTyingFlg.Tying) return MyCode;
+                // 結合工事のチェック
+                if (BaseRec.JoinFlg != (int)CommonDefine.BaseInfoJoinFlg.Standard)
+                {
+                    // 結合工事は結合親工事番号を返す
+                    int FuncCnt = 0;
+                    ArrayList ParList = new ArrayList();
+                    ClsChangeBaseInfoData.GetParentData(InputCode, ref ParList, ref FuncCnt);
+                    // データ無はエラー
+                    if (ParList.Count == 0) return InputCode;
 
-                string strLink = string.Format(" WHERE FluctuationCode = {0}", MyCode);
+                    object[] objRec = (object[])ParList[0];
+                    return CommonMotions.cnvInt(objRec[0]);
+                }
+                else
+                {
+                    // 増減工事でない場合はそのまま工事コードを返す
+                    if (BaseRec.TyingFlg != (int)CommonDefine.BaseInfoTyingFlg.Tying) return InputCode;
+                }
+                // 増減工事の場合は親コードを検索する
+                string strLink = string.Format(" WHERE FluctuationCode = {0}", InputCode);
                 ConstructionLink LinkRec = new ConstructionLink();
-                if (!LinkDB.SelectAction(strLink, ref LinkRec)) return MyCode;
+                if (!LinkDB.SelectAction(strLink, ref LinkRec)) return InputCode;
 
                 return LinkRec.ConstructionCode;
             }
@@ -97,7 +158,7 @@
             catch (Exception ex)
             {
                 logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
-                return MyCode;
+                return InputCode;
             }
             finally
             {
@@ -107,6 +168,97 @@
         }
         #endregion
 
+        #region 結合・増減の対象リストを作成する
+        /// <summary>
+        /// 結合・増減の対象リストを作成する
+        /// </summary>
+        /// <param name="CodeList"></param>
+        public static void GetTargetList(IOConstructionBaseInfo BaseDB, ref List<int> CodeList, bool ParentAdd)
+        {
+            try
+            {
+                // 親工事番号を取得する
+                int ParentCode = ClsProcessExist.GetParentConstrCode(m_ConstructionCode);
+                // データ無はエラー
+                if (ParentCode == 0) return;
+
+                // 対象工事の結合・増減を確認する
+                string strSQL = "SELECT CONSTRUCTIONCODE, JoinFlg FROM CONSTRUCTIONBASEINFO A";
+                strSQL += BaseDB.CreatePrimarykeyString(m_ConstructionCode);
+                ArrayList BaseList = new ArrayList();
+
+                if (!BaseDB.ExecuteReader(strSQL, ref BaseList)) return;
+                if (BaseList.Count == 0) return;
+
+                bool bJoinFlg = true;
+                object[] objRec1 = (object[])BaseList[0];
+                if (CommonMotions.cnvInt(objRec1[1]) == (int)CommonDefine.BaseInfoJoinFlg.Standard) bJoinFlg = false;
+
+                int iCode = CommonDefine.ProjectsStatus.First(x => x.Value.Equals("非 受 注")).Key;
+                int LinkJoin = (int)CommonDefine.LinkDataType.JoinType;
+                int LinkFluctuation = (int)CommonDefine.LinkDataType.FluctuationType;
+
+                if (bJoinFlg)
+                {
+                    // 結合工事
+                    strSQL = "SELECT A.FLUCTUATIONCODE, D.FLUCTUATIONCODE";
+                    strSQL += " FROM CONSTRUCTIONLINK A";
+                    strSQL += string.Format(" LEFT OUTER JOIN CONSTRUCTIONBASEINFO B ON B.CONSTRUCTIONCODE = A.FLUCTUATIONCODE AND B.CONSTRUCTIONSTATUSFLG != {0}", iCode);
+                    strSQL += string.Format(" LEFT JOIN CONSTRUCTIONLINK D ON D.CONSTRUCTIONCODE = A.FLUCTUATIONCODE AND D.LINKTYPE = {0}", LinkFluctuation);
+                    strSQL += string.Format(" LEFT OUTER JOIN CONSTRUCTIONBASEINFO F ON F.CONSTRUCTIONCODE = D.CONSTRUCTIONCODE AND F.CONSTRUCTIONSTATUSFLG != {0}", iCode);
+                    strSQL += string.Format(" WHERE A.CONSTRUCTIONCODE = {0}", ParentCode);
+                    strSQL += string.Format(" AND A.LINKTYPE = {0}", LinkJoin);
+                    strSQL += " ORDER BY A.FLUCTUATIONCODE ASC";
+
+                    // 親工事の追加
+                    if (ParentAdd) CodeList.Add(ParentCode);
+                }
+                else
+                {
+                    // 増減工事
+                    strSQL = "SELECT A.CONSTRUCTIONCODE, A.FLUCTUATIONCODE";
+                    strSQL += " FROM CONSTRUCTIONLINK A";
+                    strSQL += string.Format(" LEFT OUTER JOIN CONSTRUCTIONBASEINFO B ON B.CONSTRUCTIONCODE = A.FLUCTUATIONCODE AND B.CONSTRUCTIONSTATUSFLG != {0}", iCode);
+                    strSQL += string.Format(" WHERE A.CONSTRUCTIONCODE = {0}", ParentCode);
+                    strSQL += string.Format(" AND A.LINKTYPE = {0}", LinkFluctuation);
+                    strSQL += " ORDER BY A.FLUCTUATIONCODE ASC";
+
+                    // 親工事の追加
+                    CodeList.Add(ParentCode);
+                }
+
+                ArrayList TargetList = new ArrayList();
+                if (!BaseDB.ExecuteReader(strSQL, ref TargetList)) return;
+                if (TargetList.Count == 0) return;
+
+                int BreakCode = 0;
+                int ConstrCode1 = 0;
+                int ConstrCode2 = 0;
+                foreach (object[] objRec in TargetList)
+                {
+                    ConstrCode1 = CommonMotions.cnvInt(objRec[0]);
+                    ConstrCode2 = CommonMotions.cnvInt(objRec[1]);
+
+                    // 結合工事はコードを評価して追加
+                    if (bJoinFlg)
+                    {
+                        if (BreakCode != ConstrCode1)
+                        {
+                            CodeList.Add(ConstrCode1);
+                            BreakCode = ConstrCode1;
+                        }
+                    }
+                    // 全工事についてコードがあれば追加
+                    if (ConstrCode2 != 0) CodeList.Add(ConstrCode2);
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
         #region 実行可能プロセスの一覧を取得する
         /// <summary>
         /// 実行可能プロセスの一覧を取得する
@@ -114,8 +266,31 @@
         /// <param name="ConctructionCode"></param>
         public static void GetProcessList(ref List<KeyValuePair<int,string>> ProcList, int OperationPrcess)
         {
+            IOConstructionBaseInfo BaseDB = new IOConstructionBaseInfo();
             try
             {
+                // 対象工事の結合・増減を確認する
+                string strSQL = "SELECT CONSTRUCTIONCODE, JoinFlg, TyingFlg FROM CONSTRUCTIONBASEINFO A";
+                strSQL += BaseDB.CreatePrimarykeyString(m_ConstructionCode);
+                ArrayList BaseList = new ArrayList();
+
+                if (!BaseDB.ExecuteReader(strSQL, ref BaseList)) return;
+                if (BaseList.Count == 0) return;
+
+                object[] objRec1 = (object[])BaseList[0];
+                m_BaseInfoJoinFlg = CommonMotions.cnvInt(objRec1[1]);
+                m_BaseInfoTyingFlg = CommonMotions.cnvInt(objRec1[2]);
+
+                // 結合・増減工事は構成工事コードを全てとる
+                m_SearchCode = m_ConstructionCode;
+                if (m_BaseInfoJoinFlg != (int)CommonDefine.BaseInfoJoinFlg.Standard || m_BaseInfoTyingFlg != (int)CommonDefine.BaseInfoTyingFlg.Standard)
+                {
+                    // 検索工事番号を返す
+                    m_SearchCode = GetParentConstrCode(m_ConstructionCode);
+                    m_CodeList.Clear();
+                    GetTargetList(BaseDB, ref m_CodeList, false);
+                }
+
                 // 0:メニューへ戻る
                 int MenuProcNo = (int)ClsExcute.ProcessExecuteNo.MainMenu;
                 string MenuProcName = "メニューへ戻る";
@@ -191,6 +366,13 @@
                     string ProcName = ClsExcute.ProcessExecuteName[ProcNo].Replace("－", "").Replace("入力", "");
                     ProcList.Add(new KeyValuePair<int, string>(ProcNo, ProcName));
                 }
+                // 14：請求書印刷
+                if (ExistRequestPrint())
+                {
+                    int ProcNo = (int)ClsExcute.ProcessExecuteNo.RequestPrint;
+                    string ProcName = ClsExcute.ProcessExecuteName[ProcNo].Replace("－", "").Replace("入力", "");
+                    ProcList.Add(new KeyValuePair<int, string>(ProcNo, ProcName));
+                }
                 //// 15:日報一覧
                 //if (ExistDRConstruction())
                 //{
@@ -203,9 +385,45 @@
             {
                 logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
             }
+            finally
+            {
+                BaseDB.close(); BaseDB = null;
+            }
         }
         #endregion
 
+        #region Where句作成処理
+        /// <summary>
+        /// Where句作成処理
+        /// </summary>
+        /// <returns></returns>
+        private static string WhereString(string para = "")
+        {
+            try
+            {
+                string strSQL = string.Empty;
+
+                if (para.Length == 0)
+                    strSQL = " WHERE CONSTRUCTIONCODE IN (";
+                else
+                    strSQL = string.Format(" WHERE {0}CONSTRUCTIONCODE IN (", para);
+
+                for (int i = 0; i < m_CodeList.Count; i++)
+                {
+                    if (i != 0) strSQL += ", ";
+                    strSQL += m_CodeList[i].ToString();
+                }
+                strSQL += ")";
+                return strSQL;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return string.Empty;
+            }
+        }
+        #endregion
+
         #region 2:工事情報データの存在確認
         /// <summary>
         /// 2:工事情報データの存在確認
@@ -216,6 +434,10 @@
             IOConstructionBaseInfo BaseDB = new IOConstructionBaseInfo();
             try
             {
+                // 起動権限チェック
+                int Editflg = 0;
+                if (!ClsSecurityPermission.GetExecutePermission((int)ClsExcute.ProcessExecuteNo.ConstructionBaseInfo, ref Editflg)) return false;
+
                 string strSQL = BaseDB.CreatePrimarykeyString(m_ConstructionCode);
                 ConstructionBaseInfo BaseRec = new ConstructionBaseInfo();
                 if (!BaseDB.SelectAction(strSQL, ref BaseRec)) return false;
@@ -244,14 +466,26 @@
             IOEstimateData EdimateDB = new IOEstimateData();
             try
             {
-                // 工事情報入力時以外はデータ存在チェック
-                if (OperationPrcess != (int)ClsExcute.ProcessExecuteNo.ConstructionBaseInfo)
+                // 起動権限チェック
+                int Editflg = 0;
+                if (!ClsSecurityPermission.GetExecutePermission((int)ClsExcute.ProcessExecuteNo.EstimateInput, ref Editflg)) return false;
+
+                // 工事情報入力時は新規入力があるためデータ存在チェックをしない
+                if (OperationPrcess == (int)ClsExcute.ProcessExecuteNo.ConstructionBaseInfo) return true;
+
+                string strSQL = string.Empty;
+                // 結合工事以外の場合は自データのチェック
+                if (m_BaseInfoJoinFlg == (int)CommonDefine.BaseInfoJoinFlg.Standard)
                 {
-                    string strSQL = EdimateDB.CreatePrimarykeyString(m_ConstructionCode);
-                    List<EstimateData> EstimateList = new List<EstimateData>();
-                    if (!EdimateDB.SelectAction(strSQL, ref EstimateList)) return false;
-                    if (EstimateList.Count == 0) return false;
+                    strSQL = EdimateDB.CreatePrimarykeyString(m_ConstructionCode);
                 }
+                else
+                {
+                    strSQL = WhereString();
+                }
+                List<EstimateData> EstimateList = new List<EstimateData>();
+                if (!EdimateDB.SelectAction(strSQL, ref EstimateList)) return false;
+                if (EstimateList.Count == 0) return false;
 
                 return true;
             }
@@ -275,20 +509,35 @@
         private static bool ExistEstimateDataPrint()
         {
             IOEstimateData EstimateDB = new IOEstimateData();
-            IOProcessApproval ApprovalDB = new IOProcessApproval();
             try
             {
-                // 見積データの存在確認
-                string strSQL = EstimateDB.CreatePrimarykeyString(m_ConstructionCode);
-                List<EstimateData> EstimateList = new List<EstimateData>();
-                if (!EstimateDB.SelectAction(strSQL, ref EstimateList)) return false;
+                // 起動権限チェック
+                int Editflg = 0;
+                if (!ClsSecurityPermission.GetExecutePermission((int)ClsExcute.ProcessExecuteNo.EstimatePrint, ref Editflg)) return false;
+
+                // データの存在確認
+                string strSQL = "SELECT A.CONSTRUCTIONCODE, B.APPROVALCODE, B.APPROVALSTATUS";
+                strSQL += " FROM ESTIMATEDATA A, PROCESSAPPROVAL B";
+                
+                // 結合工事以外の場合は自データのチェック
+                if (m_BaseInfoJoinFlg == (int)CommonDefine.BaseInfoJoinFlg.Standard)
+                {
+                    strSQL += string.Format(" WHERE A.CONSTRUCTIONCODE = {0}", m_ConstructionCode);
+                }
+                else
+                {
+                    strSQL += WhereString("A.");
+                }
+                
+                strSQL += " AND B.CONSTRUCTIONCODE = A.CONSTRUCTIONCODE";
+                strSQL += string.Format(" AND B.APPROVALCODE = {0}", (int)ClsExcute.ApprovalListNo.EstimateApproval);
+                strSQL += string.Format(" AND B.ORDERNO = {0}", CommonDefine.s_Default_OrderNo);
+                strSQL += " AND B.SEQNO = 1";
+                strSQL += string.Format(" AND B.APPROVALSTATUS = {0}", (int)CommonDefine.ApprovalStatus.Approval);
+                strSQL += " GROUP BY A.CONSTRUCTIONCODE, B.APPROVALCODE, B.APPROVALSTATUS";
+                ArrayList EstimateList = new ArrayList();
+                if (!EstimateDB.ExecuteReader(strSQL, ref EstimateList)) return false;
                 if (EstimateList.Count == 0) return false;
-                
-                // 承認データの確認
-                strSQL += string.Format(" AND APPROVALCODE = {0} AND SEQNO = 1", (int)ClsExcute.ApprovalListNo.EstimateApproval);
-                strSQL += string.Format("  AND APPROVALSTATUS = {0}", (int)CommonDefine.ApprovalStatus.Approval);
-                ProcessApproval ApprovalRec = new ProcessApproval();
-                if (!ApprovalDB.SelectAction(strSQL, ref ApprovalRec)) return false;
 
                 return true;
             }
@@ -300,7 +549,6 @@
             finally
             {
                 EstimateDB.close(); EstimateDB = null;
-                ApprovalDB.close(); ApprovalDB = null;
             }
         }
         #endregion
@@ -315,15 +563,28 @@
             IOEstimateData EdimateDB = new IOEstimateData();
             try
             {
-                // 積算見積書入力以外はデータの存在チェック
-                if (OperationPrcess != (int)ClsExcute.ProcessExecuteNo.EstimateInput)
+                // 起動権限チェック
+                int Editflg = 0;
+                if (!ClsSecurityPermission.GetExecutePermission((int)ClsExcute.ProcessExecuteNo.EstimateBudget, ref Editflg)) return false;
+
+                // 積算見積書入力は新規入力があるためデータ存在チェックをしない
+                if (OperationPrcess != (int)ClsExcute.ProcessExecuteNo.EstimateInput) return true;
+
+                string strSQL = string.Empty;
+                // 結合工事以外の場合は自データのチェック
+                if (m_BaseInfoJoinFlg == (int)CommonDefine.BaseInfoJoinFlg.Standard)
                 {
-                    string strSQL = EdimateDB.CreatePrimarykeyString(m_ConstructionCode);
-                    List<EstimateData> EstimateList = new List<EstimateData>();
-                    if (!EdimateDB.SelectAction(strSQL, ref EstimateList)) return false;
-                    if (EstimateList.Count == 0) return false;
+                    strSQL = EdimateDB.CreatePrimarykeyString(m_ConstructionCode);
                 }
+                else
+                {
+                    strSQL = WhereString();
+                }
+                List<EstimateData> EstimateList = new List<EstimateData>();
 
+                if (!EdimateDB.SelectAction(strSQL, ref EstimateList)) return false;
+                if (EstimateList.Count == 0) return false;
+
                 return true;
             }
             catch (Exception ex)
@@ -346,27 +607,39 @@
         private static bool ExistConstructionBudget()
         {
             IOConstructionBaseInfo BaseDB = new IOConstructionBaseInfo();
-            IOEstimateData EstimateDB = new IOEstimateData();
-            IOProcessApproval ApprovalDB = new IOProcessApproval();
             try
             {
-                // 工事担当者のセット
-                string strSQL = BaseDB.CreatePrimarykeyString(m_ConstructionCode);
-                strSQL += " AND CONSTRUCTIONPERSONCODE != 0";
-                ConstructionBaseInfo BaseRec = new ConstructionBaseInfo();
-                if (!BaseDB.SelectAction(strSQL, ref BaseRec)) return false;
+                // 起動権限チェック
+                int Editflg = 0;
+                if (!ClsSecurityPermission.GetExecutePermission((int)ClsExcute.ProcessExecuteNo.ConstructionBudget, ref Editflg)) return false;
 
-                // 見積書データの存在チェック
-                strSQL = EstimateDB.CreatePrimarykeyString(m_ConstructionCode);
-                List<EstimateData> EstimateList = new List<EstimateData>();
-                if (!EstimateDB.SelectAction(strSQL, ref EstimateList)) return false;
+                // データの存在チェック
+                string strSQL = "SELECT A.CONSTRUCTIONCODE, C.APPROVALCODE, C.APPROVALSTATUS";
+                strSQL += " FROM CONSTRUCTIONBASEINFO A,ESTIMATEDATA B, PROCESSAPPROVAL C";
+                
+                // 結合工事以外の場合は自データのチェック
+                if (m_BaseInfoJoinFlg == (int)CommonDefine.BaseInfoJoinFlg.Standard)
+                {
+                    strSQL += string.Format(" WHERE A.CONSTRUCTIONCODE = {0}", m_ConstructionCode);
+                }
+                else
+                {
+                    strSQL += WhereString("A.");
+                }
 
-                // 承認データの確認
-                strSQL += string.Format(" AND APPROVALCODE = {0} AND SEQNO = 1", (int)ClsExcute.ApprovalListNo.EstimateApproval);
-                strSQL += string.Format("  AND APPROVALSTATUS = {0}", (int)CommonDefine.ApprovalStatus.Approval);
-                ProcessApproval ApprovalRec = new ProcessApproval();
-                if (!ApprovalDB.SelectAction(strSQL, ref ApprovalRec)) return false;
+                strSQL += " AND A.CONSTRUCTIONPERSONCODE != 0";
+                strSQL += " AND B.CONSTRUCTIONCODE = A.CONSTRUCTIONCODE";
+                strSQL += " AND C.CONSTRUCTIONCODE = A.CONSTRUCTIONCODE";
+                strSQL += string.Format(" AND C.APPROVALCODE = {0}", (int)ClsExcute.ApprovalListNo.EstimateApproval);
+                strSQL += string.Format(" AND C.ORDERNO = {0}", (int)CommonDefine.s_Default_OrderNo);
+                strSQL += " AND C.SEQNO = 1";
+                strSQL += string.Format(" AND C.APPROVALSTATUS = {0}", (int)CommonDefine.ApprovalStatus.Approval);
+                strSQL += " GROUP BY A.CONSTRUCTIONCODE, C.APPROVALCODE, C.APPROVALSTATUS";
 
+                ArrayList BaseRec = new ArrayList();
+                if (!BaseDB.ExecuteReader(strSQL, ref BaseRec)) return false;
+                if (BaseRec.Count == 0) return false;
+                
                 return true;
             }
             catch (Exception ex)
@@ -376,8 +649,6 @@
             }
             finally
             {
-                EstimateDB.close(); EstimateDB = null;
-                ApprovalDB.close(); ApprovalDB = null;
                 BaseDB.close(); BaseDB = null;
             }
         }
@@ -391,20 +662,33 @@
         private static bool ExistConstructionDataCopy()
         {
             IOConstructionBaseInfo BaseDB = new IOConstructionBaseInfo();
-            IOEstimateData EstimateDB = new IOEstimateData();
             try
             {
+                // 起動権限チェック
+                int Editflg = 0;
+                if (!ClsSecurityPermission.GetExecutePermission((int)ClsExcute.ProcessExecuteNo.ConstructionCopyList, ref Editflg)) return false;
+
                 // 工事情報の存在確認
-                string strSQL = BaseDB.CreatePrimarykeyString(m_ConstructionCode);
-                ConstructionBaseInfo BaseRec = new ConstructionBaseInfo();
-                if (!BaseDB.SelectAction(strSQL, ref BaseRec)) return false;
+                string strSQL = "SELECT A.CONSTRUCTIONCODE, COUNT(*)";
+                strSQL += " FROM CONSTRUCTIONBASEINFO A,ESTIMATEDATA B";
 
-                // 見積データの存在確認
-                List<EstimateData> EstimateList = new List<EstimateData>();
-                if (!EstimateDB.SelectAction(strSQL, ref EstimateList)) return false;
-                if (EstimateList.Count == 0) return false;
+                // 結合工事以外の場合は自データのチェック
+                if (m_BaseInfoJoinFlg == (int)CommonDefine.BaseInfoJoinFlg.Standard)
+                {
+                    strSQL += string.Format(" WHERE A.CONSTRUCTIONCODE = {0}", m_ConstructionCode);
+                }
+                else
+                {
+                    strSQL += WhereString("A.");
+                }
 
+                strSQL += " AND B.CONSTRUCTIONCODE = A.CONSTRUCTIONCODE";
+                strSQL += " GROUP BY A.CONSTRUCTIONCODE";
 
+                ArrayList BaseRec = new ArrayList();
+                if (!BaseDB.ExecuteReader(strSQL, ref BaseRec)) return false;
+                if (BaseRec.Count == 0) return false;
+
                 return true;
             }
             catch (Exception ex)
@@ -415,7 +699,6 @@
             finally
             {
                 BaseDB.close(); BaseDB = null;
-                EstimateDB.close(); EstimateDB = null;
             }
         }
         #endregion
@@ -428,20 +711,36 @@
         private static bool ExistPurchaseOrder()
         {
             IOConstructionBudget BudgetDB = new IOConstructionBudget();
-            IOProcessApproval ApprovalDB = new IOProcessApproval();
             try
             {
-                // 工事予算書データの存在チェック
-                string strSQL = BudgetDB.CreatePrimarykeyString(m_ConstructionCode);
-                ConstructionBudget BudgetList = new ConstructionBudget();
-                if (!BudgetDB.SelectAction(strSQL, ref BudgetList)) return false;
+                // 起動権限チェック
+                int Editflg = 0;
+                if (!ClsSecurityPermission.GetExecutePermission((int)ClsExcute.ProcessExecuteNo.PurchaseOrderEntry, ref Editflg)) return false;
 
-                // 承認データの確認
-                strSQL += string.Format(" AND APPROVALCODE = {0} AND SEQNO = 1", (int)ClsExcute.ApprovalListNo.ConstructionBudgetApproval);
-                strSQL += string.Format("  AND APPROVALSTATUS = {0}", (int)CommonDefine.ApprovalStatus.Approval);
-                ProcessApproval ApprovalRec = new ProcessApproval();
-                if (!ApprovalDB.SelectAction(strSQL, ref ApprovalRec)) return false;
+                // データの存在確認
+                string strSQL = "SELECT A.CONSTRUCTIONCODE, B.APPROVALCODE, B.APPROVALSTATUS";
+                strSQL += " FROM CONSTRUCTIONBUDGET A, PROCESSAPPROVAL B";
 
+                // 結合工事以外の場合は自データのチェック
+                if (m_BaseInfoJoinFlg == (int)CommonDefine.BaseInfoJoinFlg.Standard)
+                {
+                    strSQL += string.Format(" WHERE A.CONSTRUCTIONCODE = {0}", m_ConstructionCode);
+                }
+                else
+                {
+                    strSQL += WhereString("A.");
+                }
+
+                strSQL += " AND B.CONSTRUCTIONCODE = A.CONSTRUCTIONCODE";
+                strSQL += string.Format(" AND B.APPROVALCODE = {0}", (int)ClsExcute.ApprovalListNo.ConstructionBudgetApproval);
+                strSQL += string.Format(" AND B.ORDERNO = {0}", m_OrderNo);
+                strSQL += " AND B.SEQNO = 1";
+                strSQL += string.Format(" AND B.APPROVALSTATUS = {0}", (int)CommonDefine.ApprovalStatus.Approval);
+                strSQL += " GROUP BY A.CONSTRUCTIONCODE, B.APPROVALCODE, B.APPROVALSTATUS";
+                ArrayList BudgetList = new ArrayList();
+                if (!BudgetDB.ExecuteReader(strSQL, ref BudgetList)) return false;
+                if (BudgetList.Count == 0) return false;
+
                 return true;
             }
             catch (Exception ex)
@@ -452,7 +751,6 @@
             finally
             {
                 BudgetDB.close(); BudgetDB = null;
-                ApprovalDB.close(); ApprovalDB = null;
             }
         }
         #endregion
@@ -468,17 +766,34 @@
             IOProcessApproval ApprovalDB = new IOProcessApproval();
             try
             {
-                // 注文書データの存在チェック
-                string strSQL = OrderDB.CreatePrimarykeyString(m_ConstructionCode);
-                List<PurchaseOrder> OrderList = new List<PurchaseOrder>();
-                if (!OrderDB.SelectAction(strSQL, ref OrderList)) return false;
+                // 起動権限チェック
+                int Editflg = 0;
+                if (!ClsSecurityPermission.GetExecutePermission((int)ClsExcute.ProcessExecuteNo.PurchaseOrderPrint, ref Editflg)) return false;
 
-                // 承認データの確認
-                strSQL += string.Format(" AND APPROVALCODE = {0} AND SEQNO = 1", (int)ClsExcute.ApprovalListNo.PurchaseOrderEntryApproval);
-                strSQL += string.Format("  AND APPROVALSTATUS = {0}", (int)CommonDefine.ApprovalStatus.Approval);
-                ProcessApproval ApprovalRec = new ProcessApproval();
-                if (!ApprovalDB.SelectAction(strSQL, ref ApprovalRec)) return false;
+                // データの存在確認
+                string strSQL = "SELECT A.CONSTRUCTIONCODE, B.APPROVALCODE, B.APPROVALSTATUS";
+                strSQL += " FROM PURCHASEORDER A, PROCESSAPPROVAL B";
 
+                // 結合工事以外の場合は自データのチェック
+                if (m_BaseInfoJoinFlg == (int)CommonDefine.BaseInfoJoinFlg.Standard)
+                {
+                    strSQL += string.Format(" WHERE A.CONSTRUCTIONCODE = {0}", m_ConstructionCode);
+                }
+                else
+                {
+                    strSQL += WhereString("A.");
+                }
+
+                strSQL += " AND B.CONSTRUCTIONCODE = A.CONSTRUCTIONCODE";
+                strSQL += string.Format(" AND B.APPROVALCODE = {0}", (int)ClsExcute.ApprovalListNo.PurchaseOrderEntryApproval);
+                strSQL += string.Format(" AND B.ORDERNO = {0}", m_OrderNo);
+                strSQL += " AND B.SEQNO = 1";
+                strSQL += string.Format(" AND B.APPROVALSTATUS = {0}", (int)CommonDefine.ApprovalStatus.Approval);
+                strSQL += " GROUP BY A.CONSTRUCTIONCODE, B.APPROVALCODE, B.APPROVALSTATUS";
+                ArrayList OrderList = new ArrayList();
+                if (!OrderDB.ExecuteReader(strSQL, ref OrderList)) return false;
+                if (OrderList.Count == 0) return false;
+
                 return true;
             }
             catch (Exception ex)
